Batch = Core.class(Mesh)

function Batch:init()
	self.indices = {}
	self.vertices = {}
	self.children = {}
	self.index = 1
	self.vIndex = 1
	self.tIndex = 1
end

function Batch:addSprite(pSprite)
	self.children[#self.children+1] = pSprite
	--
	self:setIndex(self.index+0, self.tIndex+0)
	self:setIndex(self.index+1, self.tIndex+1)
	self:setIndex(self.index+2, self.tIndex+2)
	self:setIndex(self.index+3, self.tIndex+0)
	self:setIndex(self.index+4, self.tIndex+2)
	self:setIndex(self.index+5, self.tIndex+3)
	--
	self.index = self.index+6
	self.tIndex = self.tIndex+4
end


function Batch:render()
	self.vIndex = 1
	local numChild = #self.children	
	for i=1, numChild, 1 do
		self:draw(self.children[i])
	end
	self:setVertexArray(self.vertices)	
end

function Batch:draw(pSprite)
	local i = self.vIndex
	self.vertices[i+0] = pSprite.x
	self.vertices[i+1] = pSprite.y
	self.vertices[i+2] = pSprite.x + pSprite.w
	self.vertices[i+3] = pSprite.y
	self.vertices[i+4] = pSprite.x + pSprite.w
	self.vertices[i+5] = pSprite.y + pSprite.h
	self.vertices[i+6] = pSprite.x
	self.vertices[i+7] = pSprite.y + pSprite.h
	self.vIndex = self.vIndex+8
end